unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Borland.Vcl.StdCtrls, System.ComponentModel, PobieranieUchwytuOkna, System.Text;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.nfm}

procedure TForm1.Button1Click(Sender: TObject);
const MAX_COUNT=256;
var
  ProcessId :Cardinal;
  uchwytOkna :THandle;
  nazwaOkna :StringBuilder;
  nazwaKlasy :StringBuilder;
begin
  ProcessId:=0;
  try
    ProcessId:=StrToInt(Edit1.Text);
  except
    ShowMessage('Identyfikator procesu musi być liczbą');
    Exit;
  end;

  uchwytOkna:=GetMainWindowHandle(ProcessId);
  if uchwytOkna<>0 then
    begin
    nazwaOkna:=StringBuilder.Create(MAX_COUNT);
    nazwaKlasy:=StringBuilder.Create(MAX_COUNT);
    GetWindowText(uchwytOkna,nazwaOkna,MAX_COUNT);
    GetClassName(uchwytOkna,nazwaKlasy,MAX_COUNT);
    ShowMessage('Uchwyt okna: '+IntToStr(uchwytOkna)+Chr(13)+'Nazwa okna: '+nazwaOkna.ToString+Chr(13)+'Klasa okna: '+nazwaKlasy.ToString);
    end
    else
    ShowMessage('Proces o podanym numerze PID nie istnieje');
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  ProcessId :Cardinal;
  uchwytOkna :THandle;
begin
  uchwytOkna:=0;
  try
    uchwytOkna:=StrToInt(Edit2.Text);
  except
    ShowMessage('Uchwyt okna musi być liczbą');
    Exit;
  end;

  if GetWindowThreadProcessId(uchwytOkna,ProcessId)<>0 then
    ShowMessage('Identyfikator procesu: '+IntToStr(ProcessId)+Chr(13)+'Uchwyt okna (test): '+IntToStr(GetMainWindowHandle(ProcessId)))
    else
    ShowMessage('Podanemu uchwytowi nie odpowiada żadne okno');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Edit1.Text:=IntToStr(GetCurrentProcessId);
Edit2.Text:=IntToStr(Handle);
end;

end.
